
\CopiedChapter{\footnotemark[1]}{The \textit{p}-finite element method}
\label{sec:pfem}
{

\input{chapters/tikzhelper.tex}
\renewcommand\picsDir{chapters/03_pfem_pics}

In the $p$-version of the finite element method \parencite{Szabo1978, Babuska1981}, the discretization is refined by increasing the polynomial degree, resulting in exponential convergence of the error with respect to the polynomial degree and the number of unknowns if the solution is smooth. This chapter introduces the basic ideas of the multi-level $hp$ extension that follows in Chapter~\ref{sec:mlhp} in the context of single $p$-finite element meshes without refinements and with varying polynomial degrees per element and coordinate direction. This case is well known by the community and allows to introduce the multi-level $hp$ extension to higher dimensions in a familiar setting.  

\section{Mesh and data structure}
\label{sec:pfem:mesh}

The meshes considered in this chapter consist of a set of \textit{cells} that form a non-overlapping partition of the computational domain $\Omega$. A cell is a $d$-dimensional (hyper-)cuboid, i.e., a line segment in one dimension, a quadrilateral in two dimensions, a cuboid or brick in three dimensions, and so on. A \textit{finite element} is a cell that supports basis functions and is used to integrate the local finite matrices and vectors during the assembly of the global finite element equation system. Both terms are used interchangeably in this chapter in the context of $p$-finite elements. In Chapter~\ref{sec:mlhp}, the parent cells in the hierarchically refined mesh are not finite elements, as they overlap with the leaf cells and are not considered separate entities during the assembly. Instead, their contributing shape functions are added to the non-overlapping leaf cells that are the multi-level $hp$-elements.

\begin{figure}[h!]  
  \centering
  \begin{minipage}[b]{0.43\linewidth}
    \centering
    \includeTikz{}{pfem_mesh}    
    \subcaption{Cell ($=$ element) numbering}
    \label{fig:pfem:mesh:examplemesh:numbering} 
  \end{minipage}
  \hspace{0.8cm}
  \begin{minipage}[b]{0.42\linewidth}
    \newcommand{\cB}[1]{\textcolor{blue}{#1}}
    \centering
    \begin{tabular}{lrrrr}
      \toprule
      Cell  & $n_l$   & $n_r$   & $n_b$   & $n_t$  \\ 
      \midrule                                       
      0     & \cB{-1} &      3  & \cB{-1} &      1 \\  
      1     & \cB{-1} &      4  &      0  &      2 \\  
      2     & \cB{-1} &      5  &      1  & \cB{-1}\\  
      3     &      0  &      6  & \cB{-1} &      4 \\  
      4     &      1  &      7  &      3  &      5 \\  
      5     &      2  &      8  &      4  & \cB{-1}\\  
      6     &      3  &      9  & \cB{-1} &      7 \\  
      7     &      4  &     10  &      6  &      8 \\  
      8     &      5  &     11  &      7  & \cB{-1}\\  
      9     &      6  & \cB{-1} & \cB{-1} &     10 \\  
      10    &      7  & \cB{-1} &      9  &     11 \\  
      11    &      8  & \cB{-1} &     10  & \cB{-1}\\  
      \bottomrule
    \end{tabular} 
    \subcaption{Left, right, bottom, and top neighbors}
    \label{fig:pfem:mesh:examplemesh:neighbors} 
  \end{minipage}
  \caption{Example finite element mesh in two dimensions.}
  \label{fig:pfem:mesh:examplemesh}%
\end{figure}

Each cell is assigned a unique \textit{id} between $0$ and $n_{\text{el}} - 1$. Figure~\ref{fig:pfem:mesh:examplemesh:numbering} shows the cell numbering of an example mesh that is used throughout this chapter to demonstrate the construction of a $p$-finite element basis. While there is no specific restriction on the cell numbering, this particular choice seems natural as looping first over $x$ (outer loop) and then over $y$ (inner loop) leads to contiguous memory access of element-associated data. The same style of numbering the last dimension contiguously is also used in higher dimensions.

A cell has $2d$ local boundary \textit{faces}, two per coordinate direction. Here, the term \textit{face} is used generically to refer to the bounding topologies of codimension $1$, which are two bounding nodes in one dimension, four bounding edges in two dimensions, six bounding faces in three dimensions, eight bounding cubes in four dimensions, and so on. These faces are the local cell boundaries that can either be part of the domain boundary $\partial\Omega$ or they can be \textit{interfaces} to other cells. To prevent ambiguity, the term \textit{boundary} refers to the domain (mesh) boundary and is not used in connection with local cell faces. The ids of both neighbor cells in $d$ directions are stored in an adjacency array $A$ of size $(n_{el}, d, 2)$, using a dedicated \textit{no-cell} value for domain boundary faces; for example, $-1$ for signed integers or the maximum representable number for unsigned integers. Figure~\ref{fig:pfem:mesh:examplemesh:neighbors} shows the neighbor ids for all cells in~\ref{fig:pfem:mesh:examplemesh:numbering}.

Unlike conventional $p$- and $hp$-finite element approaches, the mesh is not stored as a graph of vertices, edges, faces, and so on; instead, the algorithms are formulated to only use adjacency relations between cells. The main challenge in constructing $C^0$ continuous basis functions is to handle neighboring elements with varying polynomial degrees. To simplify the description of the algorithms, the coordinate axes of neighboring elements are assumed to be aligned, which is generally not true for unstructured meshes.

\CopiedSection{\footnotemark[1]}{High-order shape functions}
\label{sec:pfem:shapefunctions}

\begin{figure}[hbt]%
  \centering%
  \vspace{0.5cm}
  \includeTikz{}{integratedlegendre}%
  \hspace{1cm}%
  \caption{One-dimensional Integrated Legendre shape functions. \reprintedA}%
  \label{fig:pfem:shapefunctions:1D}%
\end{figure}%

This section discusses the tensor-products of integrated Legendre polynomials in the local (reference) coordinates $r_0, \ldots, r_{d - 1}$, with $r_i \in [-1, 1]$, and their selective activation or deactivation. First, the integrated Legendre polynomials of degree $q$ in one dimension are defined as
%
\begin{alignat}{6} \label{eq:pfem:shapefunctions:integratedlegendre}
I_0(r) &= \frac{1}{2} (1 - r), \quad &I_1(r) &= \frac{1}{2} (1 + r), \quad &I_q(r) &= \frac{P_q(r) - P_{q-2}(r)}{\sqrt{4q-2}}  \quad                &\text{for } q > 1, \\[0.7em]
I'_0(r) &= -\frac{1}{2}, \quad &I'_1(r) &= \frac{1}{2}, \quad &I'_q(r) &= \frac{P'_q(r) - P'_{q-2}(r)}{\sqrt{4q-2}} \quad                &\text{for } q > 1, \\[0.7em]
I''_0(r) &= 0, \quad &I''_1(r) &= 0, \quad &I''_q(r) &= \frac{P''_q(r) - P''_{q-2}(r)}{\sqrt{4q-2}} \quad                &\text{for } q > 1, 
\end{alignat}
where $P_q(r)$ are the Legendre polynomials of degree $q$:
%
\begin{alignat*}{6}
P_0(r) &= 1,    \quad &P_1(r) &= r,    \quad &P_q(r) &= \frac{2q - 1}{q} r \, P_{q - 1} - \frac{q - 1}{q} P_{q - 2} \quad &\text{for } q > 1,\\[0.5em]
P'_0(r) &= 0,   \quad &P'_1(r) &= 1,   \quad &P'_q(r) &= \frac{2q - 1}{q} \Big (P_{q - 1} + r P'_{q - 1} \Big ) - \frac{q - 1}{q} P'_{q - 2} \quad &\text{for } q > 1,\\[0.5em]
P''_0(r) &= 0,   \quad &P''_1(r) &= 0,   \quad &P''_q(r) &= \frac{2q - 1}{q} \Big (2 P'_{q - 1} + r P''_{q - 1} \Big ) - \frac{q - 1}{q} P''_{q - 2} \quad &\text{for } q > 1.
\end{alignat*}
%
\begin{figure}[h]%
  \centering%
  \includeTikz{}{tensorproduct}%
  \caption{Tensor-product of integrated Legendre shape functions for $p = (3, 2)$. \reprintedA}%
  \label{fig:pfem:shapefunctions:2D}%
\end{figure}%
%
Due to several characteristics, integrated Legendre polynomials in this form are the standard choice in $p$-finite elements. First, $I_0$ is the only non-zero function on the left node and $I_1$ is the only non-zero function on the right node. All higher-order polynomials with $q > 1$ are zero on both nodes. A complete basis for a polynomial degree $p$ is obtained by selecting the functions $\{I_0, \ldots, I_p\}$. These bases are hierarchical; \textit{i.e.}, incrementing the polynomial degree adds only one function to the previous basis. 
Figure~\ref{fig:pfem:shapefunctions:1D} sketches integrated Legendre bases for different polynomial degrees. 

The construction of $d$-dimensional bases on a reference cube starts with the definition of integrated Legendre polynomials $\{ I_0, \ldots, I_{p_a} \}$ for each coordinate axis $a \in \{0, \ldots, d - 1\}$. The polynomial degrees in different coordinate axes may vary; thus, $p$ is now a tuple $(p_0, \ldots, p_{d - 1})$ with possibly different polynomial degrees per axis. This feature, for example, allows choosing different polynomial degrees in space and time for finite element discretizations of transient problems, or it can reduce the number of unknowns in combination with a capable error estimator. An element $N_{\alpha}$ in the tensor-product with the multi-index $\alpha$
%
\begin{equation} \label{eq:pfem:shapefunctions:multiindex}
  \alpha = (\alpha_0, \ldots, \alpha_{d - 1})\in \{0, \ldots, p_0\} \times \ldots \times \{0, \ldots, p_{d-1}\},
\end{equation}
%
is computed from the tensor-product of the univariate integrated Legendre polynomials in each coordinate direction:
%
\begin{equation} \label{eq:pfem:shapefunctions:tensorproduct}
  N_{\alpha}(r) = \prod_{i=0}^{d - 1} I_{\alpha_i} ( r_i ),
\end{equation}
%
where $r$ are the local coordinates $r_0$ until $r_{d - 1}$ for each direction. In two dimensions, for example,~\eqref{eq:pfem:shapefunctions:tensorproduct} becomes
\begin{equation} \label{eq:pfem:shapefunctions:tensorproduct2D}
%
  N_{(\alpha_0, \,\alpha_1)}(r_0, r_1) = I_{\alpha_0} ( r_0 ) \, I_{\alpha_1}(r_1) \qquad \text{for } \alpha_0 \in \{0, \ldots, p_0\} \text{ and } \alpha_1 \in \{0, \ldots, p_1\},
\end{equation}
%
where $r_0$ and $r_1$ are the two local coordinates. The functions in~\eqref{eq:pfem:shapefunctions:tensorproduct} and~\eqref{eq:pfem:shapefunctions:tensorproduct2D} are defined locally on each element, and they span complete polynomial spaces in the reference coordinate system. From now on, they are called shape functions to distinguish them from the finite element basis functions constructed later by mapping the shape functions of several adjacent elements from the reference to the global coordinates and ''gluing'' them together conformingly. Connecting or ''gluing'' shape functions together means assigning them the same global basis function index, as done by the algorithms of Sections~\ref{sec:pfem:locationmaps}~and~\ref{sec:mlhp:locationmaps}.

Figure~\ref{fig:pfem:shapefunctions:2D} displays the two-dimensional shape functions in~\eqref{eq:pfem:shapefunctions:tensorproduct2D} for $p = (3, 2)$. Independent of the polynomial degree, the first and second columns contain functions with support on the left and right element edges, and the first and second rows contain functions with support on the bottom and top edges. Similarly, in three dimensions, there are six two-dimensional subsets in the three-dimensional tensor-product, containing functions with support on each of the six faces.

This structure \review{generalizes} to a $d$-dimensional setting as follows. The tensor-product of the univariate integrated Legendre polynomials yields a $d$-dimensional array $N$ that is indexed by the multi-index $\alpha$, see \eqref{eq:pfem:shapefunctions:multiindex} and \eqref{eq:pfem:shapefunctions:tensorproduct}. The functions with support on the first and second face in the coordinate direction $a$ of the $d$-dimensional reference cube contain the factors $I_0(r_a)$ and $I_1(r_a)$, respectively. The subset of all such functions can be obtained by introducing an \textit{array-slicing} operation that extracts a $d - 1$-dimensional \textit{array slice} (a subarray) from $N$. A specific array slice is identified by an integer pair $(a, b)$, where $a \in \{0, \ldots, d - 1\}$ defines the fixed dimension (the axis the array slice is ''orthogonal'' to) and $b \in \{0, p_a - 1\}$ the index along the axis $a$. With this general definition, elements in the array slice $N\vert_{(a, b)}$ contain the elements of $N_\alpha$ for which $\alpha_a = b$. In the context of this thesis, the only interesting array slices are those with $b = 0$ and $b = 1$, as they extract the shape functions with support on the two faces in the direction $a$.

For example, in two dimensions, the array slice $N\vert_{(0, 1)}$ is orthogonal to axis zero at index one, and it contains the shape functions active on the right edge. Similarly, the array slice $N\vert_{(1, 0)}$ is orthogonal to axis one at index zero, and it contains the functions active on the bottom edge. The remaining two array slices, $N\vert_{(0, 0)}$ and $N\vert_{(1, 1)}$, extract the shape functions on the left and top edges.
In three dimensions, the six array slices $N\vert_{(0, 0)}$, $N\vert_{(0, 1)}$, $N\vert_{(1, 0)}$, $N\vert_{(1, 1)}$, $N\vert_{(2, 0)}$, and $N\vert_{(2, 1)}$ contain the functions with support on the left, right, front, back, bottom, and top faces, respectively. In four dimensions, there are eight three-dimensional array slices for each of the eight cubes, and so on. Together with the hierarchy in $p$, this framework forms the basis for algorithmically connecting the shape functions into $p$- and $hp$-basis functions. For example, in Section~\ref{sec:mlhp:masks}, homogeneous Dirichlet conditions are imposed on the boundaries of overlay cells by simply deactivating the corresponding array slices in the tensor-product. The presented algorithms extend well to higher dimensions because they do not introduce a further classification of the shape functions into nodal modes, edge modes, face modes, and so on, unlike traditional $p$- and $hp$-finite element approaches.

\begin{remark}%[]
 The integrated Legendre polynomials~\eqref{eq:pfem:shapefunctions:integratedlegendre} can be expanded and evaluated using Horner's scheme. However, the recursive definition is computationally more efficient when computing all shape functions $I_0 - I_p$ at once.
\end{remark}

\CopiedSection{\footnotemark[1]}{Tensor-product masks}
\label{sec:pfem:masks}

\begin{figure}[hbt]
    \includeTikz{}{logical_operations_1_initial}
    \caption{Second-order edge mode \review{(shaded in red)} in the quadratic left element is not present in the linear right element, rendering the shape function sets of both elements incompatible.}
    \label{fig:pfem:masks:booleanoperations1:a}
\end{figure}

\begin{figure}%[H]%    
    \includeTikz{}{logical_operations_1_and}
    \caption{Remove left shape function without counterpart on the right element and only connect the remaining two pairs of bilinear functions.}
    \label{fig:pfem:masks:booleanoperations1:b}
    
    \vspace{0.5cm}

    \includeTikz{}{logical_operations_1_or}
    \caption{Add corresponding second-order shape function on the right element and connect three shape function pairs with support on the shared edge into three (global) basis functions.}
    \label{fig:pfem:masks:booleanoperations1:c}
\end{figure}%
%
\begin{figure}[h!]
  \includeTikz{width=\textwidth}{logical_operations_2}%
  \caption{Restore interface compatibility between the tensor-product masks of two cells by comparing and overwriting the interface slices using logical operations. Array slices to be compared are printed in boldface; blue entries were activated due to logical \textit{or}; red entries were deactivated due to logical \textit{and}. \reprintedA}
  \label{fig:pfem:masks:logicaloperations2}
\end{figure}

In $p$-finite elements, the polynomial degree can be chosen independently on each element and in each local direction. This introduces the challenge of having non-matching sets of shape functions between elements with different polynomial degrees in the tangential directions on the interface. For example, a vertical edge in two dimensions may have two adjacent elements with different polynomial degrees in the vertical direction. When using hierarchical polynomials, the basis with the lower degree is contained \review{by the} one on the other side of the shared edge. As a result, the matching shape functions on the shared edge (up to the highest common polynomial degree) can directly be connected to form global $C^0$ basis functions. The left side of Figure~\ref{fig:pfem:masks:booleanoperations1:a} shows the tensor-product shape functions of two elements: the left with $p = 2$ and the right element with $p = 1$\review{, both with uniform polynomial order in both directions}. The set of shape functions on the left element contains a quadratic mode, which is not present in the right element, as indicated by the red color. The two linear shape functions have a corresponding counterpart in the other element and are therefore colored in green. There are two options for recovering two matching sets of shape functions: either the quadratic function is removed on the left element, or the corresponding function is added in the right element. In general, one can deactivate the additional functions on the element with a higher degree (minimum degree strategy). Alternatively, new shape functions can be added to the element with a lower degree (maximum degree strategy). Figures~\ref{fig:pfem:masks:booleanoperations1:b}~-~\ref{fig:pfem:masks:booleanoperations1:c} apply these two options to the example shown in Figure~\ref{fig:pfem:masks:booleanoperations1:a} and display the resulting basis functions after connecting the matching shape functions. 

\begin{figure}[h!]%
  \centering%
  {%
      \includeTikz{}{pfem_masks_initial_values}%
      
      \vspace{1ex}%
      
      \begin{minipage}[b]{0.44\linewidth}%
          \subcaption{Polynomial degrees}%
          \label{fig:pfem:masks:initial:a}%
      \end{minipage}%
      \hspace{0.7cm}%
      \begin{minipage}[b]{0.44\linewidth}%
          \subcaption{Initial tensor-product masks}%
          \label{fig:pfem:masks:initial:b}%
      \end{minipage}%
  }%
  
  {%
      \includeTikz{}{pfem_masks_initial_shapes}%
      \subcaption{Internal (gray), incompatible (red) and matching (green) shape functions in (b).}%
      \label{fig:pfem:masks:initial:c}%
  }%
  
  \caption{Initial activation of all $p$-finite element shape functions independent of the neighbors. \reprintedA}%
  \label{fig:pfem:masks:initial}%
\end{figure}%

This section details a data structure and an algorithm for obtaining sets of shape functions for each finite element that are compatible across the element interfaces. Compatible means that all shape functions that are non-zero on the element faces have a matching counterpart in the neighbor\review{, which} allows them to be connected to $C^0$ continuous basis functions in Section~\ref{sec:pfem:locationmaps} (assigned to the same global basis function index).
The data structure for storing the activation state of the tensor-product shape functions consists of a \textit{tensor-product mask} for each finite element. A tensor-product mask $T^{(e)}$ of an element with index $e$ is a $d$-dimensional array of Boolean entries $T^{(e)}_{\alpha}$ that determine whether the corresponding shape function $N_{\alpha}(x)$ from the tensor-product~\eqref{eq:pfem:shapefunctions:tensorproduct} is active in element $e$. Each tensor-product mask must be large enough to store all active values; entries beyond are implicitly assumed zero. For a classical $p$-finite element mesh in two dimensions with polynomial degree $p$ in both directions, the tensor-product masks become $(p + 1)\times(p + 1)$ sized matrices with only active entries.

\begin{figure}%
  \centering%
  {%
      \includeTikz{}{pfem_masks_and_values}%
      
      \vspace{1ex}%
  
      \begin{minipage}[b]{\linewidth}%
      \subcaption{Make tensor-product masks compatible using logical \textit{and}: first over $x$-, then over $y$-interfaces}%
      \label{fig:pfem:masks:and:a}%
      \end{minipage}%
  }%
  
  {%
      \includeTikz{}{pfem_masks_and1_shapes}%
      \subcaption{Intermediate state after operating on $x$-interfaces (of Figure~\ref{fig:pfem:masks:initial:c}) using logical \textit{and}}%
      \label{fig:pfem:masks:and:b}%
  }%
  
  \vspace{0.3cm}%
  {%
      \includeTikz{}{pfem_masks_and2_shapes}%
      \subcaption{Final shape functions after operating on $y$-interfaces (of \subref{fig:pfem:masks:and:b}) using logical \textit{and}}%
      \label{fig:pfem:masks:and:c}%
  }%
  
  \caption{Selectively deactivate shape functions using logical \textit{and} operations on the element-associated tensor-product masks to obtain compatible sets of shape functions.}
  \label{fig:pfem:masks:and}
  \vspace{1cm}
\end{figure}%
%
\begin{figure}%
  \centering%
  {%
      \includeTikz{}{pfem_masks_or_values}%
      
      \vspace{1ex}%
  
      \begin{minipage}[b]{\linewidth}%
      \subcaption{Make tensor-product masks compatible using logical \textit{or}: first over $x$-, then over $y$-interfaces}%
      \label{fig:pfem:masks:or:a}%
      \end{minipage}%
  }%
  
  {%
      \includeTikz{}{pfem_masks_or1_shapes}%
      \subcaption{Intermediate state after operating on $x$-interfaces (of Figure~\ref{fig:pfem:masks:initial:c}) using logical \textit{or}}%
      \label{fig:pfem:masks:or:b}%
  }%
  
  \vspace{0.3cm}%
  {%
      \includeTikz{}{pfem_masks_or2_shapes}%
      \subcaption{Final shape functions after operating on $y$-interfaces (of \subref{fig:pfem:masks:or:b}) using logical \textit{or}}%
      \label{fig:pfem:masks:or:c}%
  }%
  
  \caption{Selectively deactivate shape functions using logical \textit{or} operations on the element-associated tensor-product masks to obtain compatible sets of shape functions.}
  \label{fig:pfem:masks:or}
  \vspace{1cm}
\end{figure}%

\begin{algorithm}%
\begin{lstlisting}[gobble=2,mathescape]
  // Compare the array slices $\comment{(n, 1)}$ and $\comment{(n, 0)}$ of the nd-arrays $\comment{A_0}$ and $\comment{A_1}$ using oper-
  // ation op and overwrite them with the result. Data types are either bool or int.  
  void operateOnInterface(NdArray<Type>& $A_0$, NdArray<Type>& $A_1$, int $n$, Op op)
  {
      // Extract sizes of arrays in each direction without entry at index $\comment{n}$
      Vector $s_0$ = sizes($A_0$);
      Vector $s_1$ = sizes($A_1$);
      
      Vector $s^n_0$ = removeEntry($s_0$, $n$); 
      Vector $s^n_1$ = removeEntry($s_1$, $n$);
      
      // Compute element-wise maximum $\comment{s^n}$ of $\comment{s^n_0}$ and $\comment{s^n_1}$ and iterate over all  
      // entries in the Cartesian product [0, $\comment{s^n}$(0)] $\comment{\times}$ $\comment{\ldots}$ $\comment{\times}$ [0, $\comment{s^n}$($\comment{d}$ - 2)] 
      for(Vector $i^n$ in productIndices(maxarray($s^n_0$, $s^n_1$)))
      {
          // Insert into index tuple $\comment{i^n}$ in axis direction
          Vector $i_0$ = insertEntry($i^n$, $n$, $1$); // second face of first element
          Vector $i_1$ = insertEntry($i^n$, $n$, $0$); // first face of second element
          
          bool $e_0$ = indexExists($i_0$, $s_0$); 
          bool $e_1$ = indexExists($i_1$, $s_1$);
          
          Type $v_0$ = $A_0$($i_0$) if $e_0$ else noValue(Type);
          Type $v_1$ = $A_1$($i_1$) if $e_1$ else noValue(Type);
          
          Type $r$ = op($v_0$, $v_1$);
          
          if($v_0$ $\neq$ $r$ and not $e_0$) resize($A_0$, $i_0$);
          if($v_1$ $\neq$ $r$ and not $e_1$) resize($A_1$, $i_1$);
              
          if($v_0$ $\neq$ $r$) $A_0$($i_0$) = $r$;
          if($v_1$ $\neq$ $r$) $A_1$($i_1$) = $r$;
      }
  }
  
  // Compare array slices of all cells with second neighbor if it exists
  void operateOnInterfaces(NdArrayList<Type>& $A$, Neighbors $N$, Op op)
  {
      for(int $a$ from 0 to d - 1)          // Loop over coordinate axes
          for(int $i$ from 0 to size($N$))     // Loop over cell indices
              if(int $N_a$ = $N$($i, a, 1$); $N_a$ $\neq$ $-1$) 
                  operateOnInterface($A$($i$), $A$($N_a$), $a$, op);
  }
  
  MaskList createPfemMasks(Neighbors $N$, Degrees $p$, String strategy)
  {   
      MaskList $M$;

      // Activate full tensor-product (could use trunk space masks instead)
      for(Vector $p_e$ in $p$)
          $M$.append(Mask($p_e + 1$, true));
   
      Op op = logicalAnd if strategy == "min_degree" else logicalOr;
      
      // Recover compatibility 
      for(int it from 0 to d - 2) 
          operateOnInterfaces($M$, $N$, op);
      
      return $M$;
  }
\end{lstlisting}
\caption{Construct compatible tensor-product masks for single $p$-finite element mesh.}%
\label{alg:pfem:masks:construction}%
\end{algorithm}%

The fully activated tensor-product masks are incompatible between elements with different polynomial degrees on a shared interface. The right side of Figure~\ref{fig:pfem:masks:booleanoperations1:a} shows the two incompatible tensor-product masks for the elements with $p = 2$ and $p = 1$. They must be modified to recover a state where pairs of functions from each element with support on the shared interface can be combined to globally $C^0$ continuous basis functions. This can be done by either deactivating entries if they are not present in the neighbor (right side of Figure~\ref{fig:pfem:masks:booleanoperations1:b}) or activating entries in the neighbor if they are present in this element (right side of Figure~\ref{fig:pfem:masks:booleanoperations1:c}). The first strategy yields the minimum polynomial degree on the interface, and the second yields the maximum. The mask of the right element in Figure~\ref{fig:pfem:masks:booleanoperations1:c} was enlarged to match the higher polynomial degree of the neighbor on the interface.

Both strategies can be expressed in logical operations on the $d - 1$ dimensional interface slices in the tensor-product masks of both elements. Similar to the previous section, these operations use array slices to manipulate the Boolean mask entries corresponding to the shape functions with support on the faces of the reference cube. In this context, an \textit{interface slice} refers to an array slice of a face with an existing neighbor (the face is not part of the domain boundary). In two dimensions, these interface slices are columns or rows in the Boolean matrix that are compared element-wise using a logical \textit{and} to obtain the minimum-degree strategy (Figure~\ref{fig:pfem:masks:booleanoperations1:b}) or a logical \textit{or} to obtain the maximum-degree strategy (Figure~\ref{fig:pfem:masks:booleanoperations1:c}). The result of the logical operation is then written back to both original interface slices. Moreover, these logical operations rely on the property that elements outside the size of a mask are implicitly inactive. Figure~\ref{fig:pfem:masks:logicaloperations2} shows more examples of logical operations on interface slices for two- and three-dimensional elements. The logical \textit{or} operation may again require enlarging some of the tensor-product masks. Empty masks like those on the bottom right may occur in the hierarchical version in Section~\ref{sec:mlhp:masks}. 

In this setting, the tensor-product masks for $p$-finite element meshes are constructed in two steps. First, all masks are initialized by activating the full tensor-product up to the specified polynomial degrees. Figure~\ref{fig:pfem:masks:initial} defines tuples of polynomial degrees for the mesh of Figure~\ref{fig:pfem:mesh:examplemesh}, shows the resulting (incompatible) initial tensor-product masks, and visualizes the corresponding shape functions. In the second step, compatibility is recovered on all element interfaces using either logical \textit{and} operations for obtaining minimum interface degrees or logical \textit{or} operations for maximum degrees. Figures~\ref{fig:pfem:masks:and}~-~\ref{fig:pfem:masks:or} demonstrate these two variants to make the initial tensor-product masks of Figure~\ref{fig:pfem:masks:initial} compatible. The algorithm first loops over all interfaces in $x$- and then in $y$-direction. Some pairs of tensor-product masks have different sizes in the interface direction, which uses the definition that entries are inactive if they are not explicitly stored. In $d$ dimensions, the second step is carried out $d - 1$ times to reach all elements that the shape functions connect to. For example, in three dimensions, the basis functions associated with an edge may be supported by four elements; hence, information needs to travel diagonally by communicating over two interfaces. The second step of Section~\ref{sec:mlhp:masks} may clarify this information transfer as already two iterations are necessary in two dimensions. Algorithm~\ref{alg:pfem:masks:construction} shows the construction of tensor-product masks for a $d$-dimensional mesh.

One major difference compared to other $p$- and $hp$- finite element approaches is that they often use data structures with unique entities for all topological subcomponents, such as nodes, edges, and faces, with their associated polynomial degrees. For example, a unique edge may be introduced for each pair of adjacent elements in a two-dimensional $p$-finite element mesh, where the associated polynomial degree in the tangential direction is chosen from one of the two elements. However, the resulting data structure becomes drastically more complex with higher dimensions (containing $3^d$~entities per element in total). There, the runtime and memory requirements for creating and maintaining meshes may become dominant. Moreover, evaluating the basis functions requires considering all subcomponents and their respective polynomial degrees per local direction, which complicates the implementation and can also negatively influence the performance of the linear system assembly.

\begin{figure}[h!]%
  \centering%
  \includeTikz{}{pfem_maps_1_initial_connect-x}%
  
  \vspace{1ex}
  
  \begin{minipage}[b]{0.44\linewidth}%
      \subcaption{Assign unique indices}%
      \label{fig:pfem:locationmaps:construction:a}%
  \end{minipage}%
  \hspace{0.045\linewidth}%
  \begin{minipage}[b]{0.44\linewidth}%
      \subcaption{Connect in $x$}%
      \label{fig:pfem:locationmaps:construction:b}%
  \end{minipage}%

  \vspace{0.3cm}%

  \centering%
  \includeTikz{}{pfem_maps_2_connect-y_final}%
  
  \vspace{1ex}
  
  \begin{minipage}[b]{0.44\linewidth}%
      \subcaption{Connect in $y$}%
      \label{fig:pfem:locationmaps:construction:c}%
  \end{minipage}%
  \hspace{0.045\linewidth}%
  \begin{minipage}[b]{0.44\linewidth}%
      \renewcommand{\thesubfigure}{e}%
      \subcaption{Eliminate unassigned indices using (\subref{fig:pfem:locationmaps:construction:d})}%
      \label{fig:pfem:locationmaps:construction:e}%
  \end{minipage}%
  
  \vspace{0.4cm}%
  {%
      \centering%
      \includeTikz{width=158.3mm}{pfem_maps_3_index-map}%0.942\linewidth
      \renewcommand{\thesubfigure}{d}%
      \subcaption{Index map}%
      \label{fig:pfem:locationmaps:construction:d}%
  }%

  \caption{Glue shape functions from Figure~\ref{fig:pfem:masks:and:a} together into compatible basis functions. \reprintedA}
  \label{fig:pfem:locationmaps:construction}
\end{figure}

\begin{figure}[h!]
    \centering
    \includeTikz{}{pfem_basis}%
    \caption{Connected $p$-finite element basis functions according to Figure~\ref{fig:pfem:locationmaps:construction:e}.}
    \label{fig:mlhp:locationmaps:basisfunctions}
\end{figure}

\begin{algorithm}%
\begin{lstlisting}[gobble=2,mathescape]
  [LocationMatrixList, int] initializeGlobalIndices(MaskList $M$)
  {
      LocationMatrixList $G$; int $n_{\text{ids}}$ = $0$;
      
      for(int $i$ from 0 to size($M$) - 1)
      {
          Mask $M_i$ = $M$($i$);
          LocationMatrix $G_i$(sizes($M_i$));
          
          // Loop over all tensor-product entries (d nested loops)
          for(Vector $j$ in productIndices(sizes($M_i$)))
              $G_i$($j$) = $n_{\text{ids}}$++ if $M_i$($j$) else -1;
              
          $G$.append($G_i$);
      }
      
      return [$G$, $n$];
  }
  
  void removeUnassignedIndices(LocationMatrixList& $G$, int $n_{\text{ids}}$)
  {
      Vector exists($n_{\text{ids}}$, 0);
      Vector map($n_{\text{ids}}$, -1);
      
      // Activate entries in exists vector 
      for(LocationMatrix $G_i$ in $G$)
          for(Vector $j$ in productIndices(sizes($G_i$)))
              if($G_i$($j$) $\neq$ -1)
                  exists($G_i$($j$)) = 1;
     
      int $n_{\text{new}}$ = 0;
      
      // Count active dofs upwards into map
      for(int $i$ from 0 to nids - 1)
          map($i$) = $n_{\text{new}}$++ if exists($i$) else $-1$;
      
      // Reassign indices in location matrices
      for(LocationMatrix& $G_i$ in $G$)
          for(Vector $j$ in productIndices(sizes($G_i$)))
              if($G_i$($j$) $\neq$ -1)
                  $G_i$($j$) = map($G_i$($j$))
  }
  
  // Create location matrix with global ids for each tensor-product mask
  void createPfemLocationMatrices(MaskList $M$, Neighbors $N$)
  {
      LocationMatrixList $G$, int $n_{\text{ids}}$ = initializeGlobalIndices($M$);
      
      for(int it from 0 to d - 1) 
          operateOnInterfaces($G$, $N$, minimum);
          
      removeUnassignedIndices($G$, $n_{\text{ids}}$);
      
      return $G$;
  }
\end{lstlisting}
\caption{Construct location matrices for a single $p$-finite element mesh.}%
\label{alg:pfem:locationmaps:construction}%
\end{algorithm}%

\CopiedSection{\footnotemark[1]}{Location matrices}
\label{sec:pfem:locationmaps}

The tensor-product masks constructed in the previous section determine the active shape functions for all elements, such that they have matching counterparts across all interfaces. The remaining task is to connect sets of shape functions from different elements into basis functions by assigning them to the same global basis function index. This data is stored by introducing a \textit{location matrix} for each tensor-product mask with equal size containing the global basis function index for each active entry or otherwise some value, e.g., $-1$ or the maximum representable number for inactive entries. In higher dimensions, the location matrices are $d$-dimensional arrays containing the basis function indices.

The algorithm to populate the location matrices starts by assigning a unique global index to all shape functions, counting upwards from zero. Figure~\ref{fig:pfem:locationmaps:construction:a} shows the initialization of the location matrices for the tensor-product masks of the minimum-degree strategy (right side of Figure~\ref{fig:pfem:masks:and:a}). 
Then, matching shape functions are connected by looping over all element interfaces, comparing the corresponding interface slices in the location matrices using the \textit{minimum} operation (selecting the smaller of both indices), and overwriting them with the result. The only difference to the interface operations in the second step of Section~\ref{sec:pfem:masks} is the data type (integers instead of Boolean values) and the operation (\textit{minimum} instead of logical \textit{and} or logical \textit{or}). This step automatically determines the smallest index for each set of shape functions that shall be connected and propagates this information back to their entries in the location matrices. Figures~\ref{fig:pfem:locationmaps:construction:b}~and~\ref{fig:pfem:locationmaps:construction:c} demonstrate this process by connecting the indices in the $x$- and then in the $y$-direction. Mesh topologies that are not Cartesian (e.g., an L-shaped domain with axis-aligned elements) may require again multiple iterations of this step.
This step leaves some \review{empty} indices \review{(i.e., }without contributions from any elements\review{)}, as their original shape functions have been assigned to a different index. These ''gaps'' in the global numbering are eliminated by constructing a new set of compressed indices in Figure~\ref{fig:pfem:locationmaps:construction:e} that is obtained by applying the index map below. \review{Figure~\ref{fig:mlhp:locationmaps:basisfunctions} shows the} resulting basis functions for this example. Algorithm~\ref{alg:pfem:locationmaps:construction} summarizes the creation of the location matrices and thus finalizes the construction of the $p$-finite element basis.

\begin{remark}%[]
  Linearizing a location matrix and filtering inactive entries ($-1$ values) yields a global index vector called location maps or an element freedom table.
\end{remark}

\CopiedSection{\footnotemark[1]}{Trunk space} 
\label{sec:pfem:trunkspace}

\begin{figure}[hbt!]
    \centering
    \includeTikz{width=\textwidth}{trunk_space_monomials}%
    \caption{Monomials for $p = (3, 4)$. \reprintedA}
    \label{fig:pfem:trunkspace:monomials}
\end{figure}

\begin{figure}[b!]
    \centering
    \includeTikz{width=\textwidth}{trunk_space_2D}%
    \caption{Construction of two-dimensional trunk space initial tensor-product masks. \reprintedA}
    \label{fig:pfem:trunkspace:2D}
\end{figure}

Section~\ref{sec:pfem:masks} mentions that using all functions from the tensor-product is not always necessary. Within a monomial basis,
%
\begin{equation}
  \left \{ \, r_0^{\alpha_0}  \cdot \, ... \, \cdot r_{d - 1}^{\alpha_{d - 1}} 
    \; \big | \; 
    \text{for } \alpha_i = 0 , ... , p_i \, \right \},
\end{equation}
%
one can pick only functions where $\sum \alpha_i \leq \max p_i$ without reducing the convergence order. Figure~\ref{fig:pfem:trunkspace:monomials} shows the monomials for a tensor-product space with $p=(3, 4)$ compared to the reduced basis containing only polynomials with a combined order smaller or equal to $\max p_i = 4$.


As monomials are unsuitable for constructing compatible finite element bases, this concept is transferred to integrated Legendre functions. In Section~\ref{sec:pfem:masks}, the algorithm for compatible shape functions started with a full tensor-product mask for leaf cells. Instead, one can construct initial trunk space masks by only activating entries of $M_{\boldsymbol{\alpha}}$ if $\,\sum \alpha_i \leq \max p_i$. The integrated Legendre functions are hierarchical except in the first two functions ($I_0$ and $I_1$ are linear). As a result, a function with component $I_0(r_i)$ must be inactive, when the corresponding function with component $I_1(r_i)$ is inactive. Therefore, the first array slice for each coordinate axis is copied to the second array slice. Figures~\ref{fig:pfem:trunkspace:2D} and~\ref{fig:pfem:trunkspace:3D} demonstrate this procedure on two- and three-dimensional examples. 
 
\begin{figure}[t!]
    \centering
    \includeTikz{width=\textwidth}{trunk_space_3D}%
    \caption{Construction of three-dimensional trunk space initial tensor-product masks. \reprintedA}
    \label{fig:pfem:trunkspace:3D}
\end{figure}

\review{The trunk space significantly reduces the number of unknowns compared to a tensor-product space of the same polynomial degree without compromising the convergence order. Removing basis functions that are not essential for polynomial completeness (and, thus, the convergence order) decreases the computational cost significantly. However, this reduces the accuracy of the solution at the same time.}
%While using a trunk space does not reduce the order of convergence, it can significantly reduce the \review{computational cost compared to a tensor-product space of the same polynomial degree, while also reducing the accuracy.} 
When increasing the polynomial degree to compensate, one generally \review{still} obtains fewer degrees of freedom for a given accuracy at the cost of having higher connectivity per unknown. With higher dimensions, the difference between \review{them increases} as the limit for $p \to \infty$ yields $d!$ times fewer unknowns per element (assuming uniform $p$ in all directions). This limit derives from considering an $n$-simplex in $d$-dimensional space with one vertex at the origin and one vertex on each coordinate axis with distance $1$. The volume of this simplex is $1/d!$, while the volume of the corresponding unit-$n$-cube is $1$.

\FloatBarrier

}